#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_VipPointsMallCFG.h"
std::auto_ptr<M_VipPointsMallCFG> M_VipPointsMallCFG::msSingleton(nullptr);

int M_VipPointsMallCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_VipPointsMallCFGData* M_VipPointsMallCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_VipPointsMallCFGData>& M_VipPointsMallCFG::GetMapData()
{
	return mMapData;
}

void M_VipPointsMallCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_VipPointsMallCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_VipPointsMallCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mItemDesc = element->Attribute("ItemDesc");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mDailyStock = element->IntAttribute("DailyStock");
		data.mVipNtegralCount = element->IntAttribute("VipNtegralCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_VipPointsMallCFG Loaded. Load Data:%u", mMapData.size());
}

void M_VipPointsMallCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_VipPointsMallCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_VipPointsMallCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_VipPointsMallCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readString(L, "ItemDesc", data.mItemDesc);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readInt(L, "DailyStock", data.mDailyStock);
		LuaCfgHelper::readInt(L, "VipNtegralCount", data.mVipNtegralCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_VipPointsMallCFG Loaded. Load Data:%u", mMapData.size());
}

void M_VipPointsMallCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_VipPointsMallCFG* M_VipPointsMallCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_VipPointsMallCFG());
	}
	return msSingleton.get();
}

void M_VipPointsMallCFG::Release()
{
	msSingleton.reset(nullptr);
}
